diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 62a6702e..ad080bcf 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -129,358 +244,1042 @@ final case class SquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
   def encode = SquadDetailDefinitionUpdateMessage.encode(this)
 }
 
-object SquadPositionDetail2 {
-  final val Blank : SquadPositionDetail2 = SquadPositionDetail2()
-  final val Closed : SquadPositionDetail2 = SquadPositionDetail2(is_closed = Some(true), None, None, None, None, None)
-  final val Open : SquadPositionDetail2 = SquadPositionDetail2(is_closed = Some(false), None, None, None, None, None)
+object SquadPositionDetail {
+  /**
+    * A featureless squad position.
+    * References the default overloaded constructor.
+    */
+  final val Blank : SquadPositionDetail = SquadPositionDetail()
+  /**
+    * An unavailable squad position.
+    */
+  final val Closed : SquadPositionDetail = SquadPositionDetail(is_closed = Some(true), None, None, None, None, None)
+  /**
+    * An available squad position.
+    */
+  final val Open : SquadPositionDetail = SquadPositionDetail(is_closed = Some(false), None, None, None, None, None)
 
-  def apply() : SquadPositionDetail2 = SquadPositionDetail2(None, None, None, None, None, None)
-
-  def apply(role : String, detailed_orders : Option[String]) : SquadPositionDetail2 = SquadPositionDetail2(None, Some(role), detailed_orders, None, None, None)
-
-  def apply(role : Option[String], detailed_orders : String) : SquadPositionDetail2 = SquadPositionDetail2(None, role, Some(detailed_orders), None, None, None)
-
-  def apply(role : String, detailed_orders : String) : SquadPositionDetail2 = SquadPositionDetail2(None, Some(role), Some(detailed_orders), None, None, None)
-
-  def apply(requirements : Set[CertificationType.Value]) : SquadPositionDetail2 = SquadPositionDetail2(None, None, None, Some(requirements), None, None)
-
-  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value]) : SquadPositionDetail2 = SquadPositionDetail2(None, Some(role), Some(detailed_orders), Some(requirements), None, None)
-
-  def apply(char_id : Long) : SquadPositionDetail2 = SquadPositionDetail2(None, None, None, None, Some(char_id), None)
-
-  def apply(name : String) : SquadPositionDetail2 = SquadPositionDetail2(None, None, None, None, None, Some(name))
-
-  def apply(char_id : Long, name : String) : SquadPositionDetail2 = SquadPositionDetail2(None, None, None, None, Some(char_id), Some(name))
-
-  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], char_id : Long, name : String) : SquadPositionDetail2 = SquadPositionDetail2(is_closed = Some(false), Some(role), Some(detailed_orders), Some(requirements), Some(char_id), Some(name))
+  /**
+    * An overloaded constructor that produces a featureless squad position.
+    * @return a `SquadPositionDetail` object
+    */
+  def apply() : SquadPositionDetail = SquadPositionDetail(None, None, None, None, None, None)
+  /**
+    * An overloaded constructor that produces a full squad position with a role, detailed orders, and certification requirements.
+    * This basically defines an available squad position that is unoccupied.
+    * @return a `SquadPositionDetail` object
+    */
+  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(Some(false), Some(role), Some(detailed_orders), Some(requirements), Some(char_id), Some(name))
 }
 
 object SquadPositionEntry {
-  import SquadDetailDefinitionUpdateMessage.paddedStringMetaCodec
-
-  def apply(index : Int, detail : SquadPositionDetail2) : SquadPositionEntry = SquadPositionEntry(index, Some(detail))
-
-  private val isClosedCodec : Codec[SquadPositionDetail2] = bool.exmap[SquadPositionDetail2] (
-    state => Attempt.successful(SquadPositionDetail2(Some(state), None, None, None, None, None)),
-    {
-      case SquadPositionDetail2(Some(state), _, _, _, _, _) =>
-        Attempt.successful(state)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad position data for availability"))
-    }
-  )
-
-  private def roleCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail2] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail2] (
-    role => Attempt.successful(SquadPositionDetail2(role, None)),
-    {
-      case SquadPositionDetail2(_, Some(role), _, _, _, _) =>
-        Attempt.successful(role)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad position data for role"))
-    }
-  )
-
-  private def ordersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail2] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail2] (
-    orders => Attempt.successful(SquadPositionDetail2(None, orders)),
-    {
-      case SquadPositionDetail2(_, _, Some(orders), _, _, _) =>
-        Attempt.successful(orders)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad position data for detailed orders"))
-    }
-  )
-
-  private val requirementsCodec : Codec[SquadPositionDetail2] = ulongL(46).exmap[SquadPositionDetail2] (
-    requirements => Attempt.successful(SquadPositionDetail2(CertificationType.fromEncodedLong(requirements))),
-    {
-      case SquadPositionDetail2(_, _, _, Some(requirements), _, _) =>
-        Attempt.successful(CertificationType.toEncodedLong(requirements))
-      case _ =>
-        Attempt.failure(Err("failed to encode squad position data for certification requirements"))
-    }
-  )
-
-  private val charIdCodec : Codec[SquadPositionDetail2] = uint32L.exmap[SquadPositionDetail2] (
-    char_id => Attempt.successful(SquadPositionDetail2(char_id)),
-    {
-      case SquadPositionDetail2(_, _, _, _, Some(char_id), _) =>
-        Attempt.successful(char_id)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for member id"))
-    }
-  )
-
-  private def nameCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail2] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail2] (
-    name => Attempt.successful(SquadPositionDetail2(name)),
-    {
-      case SquadPositionDetail2(_, _, _, _, _, Some(orders)) =>
-        Attempt.successful(orders)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad position data for member name"))
-    }
-  )
-
   /**
-    * `Codec` for failing to determine a valid `Codec` based on the entry data.
-    * This `Codec` is an invalid codec that does not read any bit data.
-    * The `conditional` will always return `None` because
-    * its determining conditional statement is explicitly `false`
-    * and all cases involving explicit failure.
+    * An overloaded constructor.
+    * @return a `SquadPositionEntry` object
     */
-  private def failureCodec(code : Int) : Codec[SquadPositionDetail2] = conditional(included = false, bool).exmap[SquadPositionDetail2] (
-    _ => Attempt.failure(Err(s"decoding with unhandled codec - $code")),
-    _ => Attempt.failure(Err(s"encoding with unhandled codec - $code"))
-  )
-
-  private final case class LinkedSquadPositionInfo(code : Int, info : SquadPositionDetail2, next : Option[LinkedSquadPositionInfo])
-
-  /**
-    * Concatenate a `SquadInfo` object chain into a single `SquadInfo` object.
-    * Recursively visits every link in a `SquadInfo` object chain.
-    * @param info the current link in the chain
-    * @param squadInfo the persistent `SquadInfo` concatenation object;
-    *                  defaults to `SquadInfo.Blank`
-    * @return the concatenated `SquadInfo` object
-    */
-  @tailrec
-  private def unlinkSquadPositionInfo(info : Option[LinkedSquadPositionInfo], squadInfo : SquadPositionDetail2 = SquadPositionDetail2.Blank) : SquadPositionDetail2 = {
-    info match {
-      case None =>
-        squadInfo
-      case Some(sqInfo) =>
-        unlinkSquadPositionInfo(sqInfo.next, squadInfo And sqInfo.info)
-    }
-  }
-
-  /**
-    * Decompose a single `SquadInfo` object into a `SquadInfo` object chain of the original's fields.
-    * The fields as a linked list are explicitly organized "leader", "task", "zone_id", "size", "capacity,"
-    * or as "(leader, (task, (zone_id, (size, (capacity, None)))))" when fully populated and composed.
-    * @param info a `SquadInfo` object that has all relevant fields populated
-    * @return a linked list of `SquadInfo` objects, each with a single field from the input `SquadInfo` object
-    */
-  private def linkSquadPositionInfo(info : SquadPositionDetail2) : LinkedSquadPositionInfo = {
-    //import scala.collection.immutable.::
-    Seq(
-      (5, SquadPositionDetail2(None, None, None, info.requirements, None, None)),
-      (4, SquadPositionDetail2(None, None, None, None, None, info.name)),
-      (3, SquadPositionDetail2(None, None, None, None, info.char_id, None)),
-      (2, SquadPositionDetail2(None, None, info.detailed_orders, None, None, None)),
-      (1, SquadPositionDetail2(None, info.role, None, None, None, None)),
-      (0, SquadPositionDetail2(info.is_closed, None, None, None, None, None))
-    ) //in reverse order so that the linked list is in the correct order
-      .filterNot { case (_, sqInfo) => sqInfo == SquadPositionDetail2.Blank}
-    match {
-      case Nil =>
-        throw new Exception("no linked list squad position fields encountered where at least one was expected") //bad end
-      case x :: Nil =>
-        val (code, squadInfo) = x
-        LinkedSquadPositionInfo(code, squadInfo, None)
-      case x :: xs =>
-        val (code, squadInfo) = x
-        linkSquadPositionInfo(xs, LinkedSquadPositionInfo(code, squadInfo, None))
-    }
-  }
-
-  /**
-    * Decompose a single `SquadInfo` object into a `SquadInfo` object chain of the original's fields.
-    * The fields as a linked list are explicitly organized "leader", "task", "zone_id", "size", "capacity,"
-    * or as "(leader, (task, (zone_id, (size, (capacity, None)))))" when fully populated and composed.
-    * @param infoList a series of paired field codes and `SquadInfo` objects with data in the indicated fields
-    * @return a linked list of `SquadInfo` objects, each with a single field from the input `SquadInfo` object
-    */
-  @tailrec
-  private def linkSquadPositionInfo(infoList : Seq[(Int, SquadPositionDetail2)], linkedInfo : LinkedSquadPositionInfo) : LinkedSquadPositionInfo = {
-    if(infoList.isEmpty) {
-      linkedInfo
-    }
-    else {
-      val (code, data) = infoList.head
-      linkSquadPositionInfo(infoList.tail, LinkedSquadPositionInfo(code, data, Some(linkedInfo)))
-    }
-  }
-
-  private def listing_codec(size : Int, bitsOverByte : StreamLengthToken) : Codec[LinkedSquadPositionInfo] = {
-    import shapeless.::
-    (
-      uint4 >>:~ { code =>
-        selectCodecAction(code,  bitsOverByte.Add(4)) >>:~ { _ =>
-          modifyCodecPadValue(code, bitsOverByte)
-          conditional(size - 1 > 0, listing_codec(size - 1, bitsOverByte)).hlist
-        }
-      }
-      ).xmap[LinkedSquadPositionInfo] (
-      {
-        case code :: entry :: next :: HNil =>
-          LinkedSquadPositionInfo(code, entry, next)
-      },
-      {
-        case LinkedSquadPositionInfo(code, entry, next) =>
-          code :: entry :: next :: HNil
-      }
-    )
-  }
-
-  private def selectCodecAction(code : Int, bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail2] = {
-    code match {
-      case 0 => isClosedCodec
-      case 1 => roleCodec(bitsOverByte)
-      case 2 => ordersCodec(bitsOverByte)
-      case 3 => charIdCodec
-      case 4 => nameCodec(bitsOverByte)
-      case 5 => requirementsCodec
-      case _ => failureCodec(code)
-    }
-  }
-
-  private def modifyCodecPadValue(code : Int, bitsOverByte : StreamLengthToken) : StreamLengthToken = {
-    code match {
-      case 0 => bitsOverByte.Add(1) //additional 1u
-      case 1 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
-      case 2 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
-      case 3 => bitsOverByte //32u = no added padding
-      case 4 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
-      case 5 => bitsOverByte.Add(6) //46u = 5*8u + 6u = additional 6u
-      case _ => bitsOverByte.Length = Int.MinValue //wildly incorrect
-    }
-  }
-
-  private def squad_member_details_codec(bitsOverByte : StreamLengthToken) : Codec[LinkedSquadPositionInfo] = {
-    import shapeless.::
-    (
-      uint8 >>:~ { size =>
-        listing_codec(size, bitsOverByte).hlist
-      }
-      ).xmap[LinkedSquadPositionInfo] (
-      {
-        case _ :: info :: HNil =>
-          info
-      },
-      info => {
-        var i = 1
-        var dinfo = info
-        while(dinfo.next.nonEmpty) {
-          i += 1
-          dinfo = dinfo.next.get
-        }
-        i :: info :: HNil
-      }
-    )
-  }
-
-  def codec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionEntry] = {
-    import shapeless.::
-    /*
-     import net.psforever.newcodecs.newcodecs
-//        newcodecs.binary_choice[Option[LinkedSquadPositionInfo] :: HNil](
-//          index < 255,
-//          (bool :: squad_member_details_codec(bitsOverByte.Add(1))).exmap[Option[LinkedSquadPositionInfo] :: HNil] (
-//            {
-//              case _ :: info :: HNil => Attempt.Successful(Some(info) :: HNil)
-//            },
-//            {
-//              case Some(info) :: HNil => Attempt.Successful(true :: info :: HNil)
-//              case None :: HNil => Attempt.Failure(Err(s"this data for this position should not be None - $index < 255"))
-//            }
-//          ),
-//          bits.xmap[Option[LinkedSquadPositionInfo] :: HNil] (
-//            _ => None :: HNil,
-//            {
-//              case _ :: HNil => BitVector.empty
-//            }
-//          )
-//        )
-    */
-    (
-      ("index" | uint8) >>:~ { index =>
-        conditional(index < 255, bool :: squad_member_details_codec(bitsOverByte.Add(1))) ::
-        conditional(index == 255, bits)
-      }
-      ).xmap[SquadPositionEntry] (
-      {
-        case 255 :: _ :: _ :: HNil =>
-          SquadPositionEntry(255, None)
-        case ndx :: Some(_ :: info :: HNil) :: _ :: HNil =>
-          SquadPositionEntry(ndx, Some(unlinkSquadPositionInfo(Some(info))))
-      },
-      {
-        case SquadPositionEntry(255, _) =>
-          255 :: None :: None :: HNil
-        case SquadPositionEntry(ndx, Some(info)) =>
-          ndx :: Some(true :: linkSquadPositionInfo(info) :: HNil) :: None :: HNil
-      }
-    )
-  }
+  def apply(index : Int, detail : SquadPositionDetail) : SquadPositionEntry = SquadPositionEntry(index, Some(detail))
 }
 
 object SquadDetail {
-  final val Blank = SquadDetail(None, None, None, None, None, None, None, None, None)
-
-  def apply(leader_char_id : Long) : SquadDetail = SquadDetail(None, None, Some(leader_char_id), None, None, None, None, None, None)
-
-  def apply(leader_char_id : Long, leader_name : String) : SquadDetail = SquadDetail(None, None, Some(leader_char_id), None, Some(leader_name), None, None, None, None)
-
-  def apply(leader_name : String, task : Option[String]) : SquadDetail = SquadDetail(None, None, None, None, Some(leader_name), task, None, None, None)
-
-  def apply(leader_name : Option[String], task : String) : SquadDetail = SquadDetail(None, None, None, None, leader_name, Some(task), None, None, None)
-
-  def apply(zone_id : PlanetSideZoneID) : SquadDetail = SquadDetail(None, None, None, None, None, None, Some(zone_id), None, None)
-
-  def apply(member_list : List[SquadPositionEntry]) : SquadDetail = SquadDetail(None, None, None, None, None, None, None, None, Some(member_list))
+  /**
+    * A featureless squad.
+    * References the default overloaded constructor.
+    */
+  final val Blank = SquadDetail()
 
+  /**
+    * An overloaded constructor that produces a featureless squad.
+    * @return a `SquadDetail` object
+    */
+  def apply() : SquadDetail = SquadDetail(None, None, None, None, None, None, None, None, None)
+  /**
+    * An overloaded constructor that produces a complete squad with all fields populated.
+    * @return a `SquadDetail` object
+    */
   def apply(unk1 : Int, unk2 : Int, leader_char_id : Long, unk3 : Long, leader_name : String, task : String, zone_id : PlanetSideZoneID, unk7 : Int, member_info : List[SquadPositionEntry]) : SquadDetail = {
     SquadDetail(Some(unk1), Some(unk2), Some(leader_char_id), Some(unk3), Some(leader_name), Some(task), Some(zone_id), Some(unk7), Some(member_info))
   }
+
+  //individual field overloaded constructors
+  def Field1(unk1 : Int) : SquadDetail =
+    SquadDetail(Some(unk1), None, None, None, None, None, None, None, None)
+  def LeaderCharId(char_id : Long) : SquadDetail =
+    SquadDetail(None, None, Some(char_id), None, None, None, None, None, None)
+  def Field3(char_id : Option[Long], unk3 : Long) : SquadDetail =
+    SquadDetail(None, None, None, Some(unk3), None, None, None, None, None)
+  def LeaderName(name : String) : SquadDetail =
+    SquadDetail(None, None, None, None, Some(name), None, None, None, None)
+  def Leader(char_id : Long, name : String) : SquadDetail =
+    SquadDetail(None, None, Some(char_id), None, Some(name), None, None, None, None)
+  def Task(task : String) : SquadDetail =
+    SquadDetail(None, None, None, None, None, Some(task), None, None, None)
+  def ZoneId(zone : PlanetSideZoneID) : SquadDetail =
+    SquadDetail(None, None, None, None, None, None, Some(zone), None, None)
+  def Field7(unk7 : Int) : SquadDetail =
+    SquadDetail(None, None, None, None, None, None, None, Some(unk7), None)
+  def Members(list : List[SquadPositionEntry]) : SquadDetail =
+    SquadDetail(None, None, None, None, None, None, None, None, Some(list))
 }
 
 object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefinitionUpdateMessage] {
+  /**
+    * The patterns necessary to read uncoded squad data.
+    * All squad fields and all squad position fields are parsed.
+    */
+  object FullSquad {
+    /**
+      * The first squad position entry has its first string (`role`) field padded by a constant amount.
+      */
+    private val first_position_codec : Codec[SquadPositionDetail] = basePositionCodec(bitsOverByteLength = 1, DefaultRequirements)
+    /**
+      * All squad position entries asides from the first have unpadded strings.
+      * The very first entry aligns the remainder of the string fields along byte boundaries.
+      */
+    private val position_codec : Codec[SquadPositionDetail] = basePositionCodec(bitsOverByteLength = 0, DefaultRequirements)
+
+    /**
+      * Internal class for linked list operations.
+      * @param info details regarding the squad position
+      * @param next if there is a "next" squad position
+      */
+    private final case class LinkedFields(info: SquadPositionDetail, next: Option[LinkedFields])
+
+    /**
+      * Parse each squad position field in the bitstream after the first one.
+      * @return a pattern outlining sequential squad positions
+      */
+    private def subsequent_member_codec : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        //disruptive coupling action (e.g., flatPrepend) is necessary for recursive Codec
+        ("member" | position_codec) >>:~ { _ =>
+          optional(bool, "next" | subsequent_member_codec).hlist
+        }
+        ).xmap[LinkedFields] (
+        {
+          case a :: b :: HNil =>
+            LinkedFields(a, b)
+        },
+        {
+          case LinkedFields(a, b) =>
+            a :: b :: HNil
+        }
+      )
+    }
+
+    /**
+      * Parse the first squad position field in the bitstream.
+      * @return a pattern outlining sequential squad positions
+      */
+    private def initial_member_codec : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        ("member" | first_position_codec) ::
+          optional(bool, "next" | subsequent_member_codec)
+        ).xmap[LinkedFields] (
+        {
+          case a :: b :: HNil =>
+            LinkedFields(a, b)
+        },
+        {
+          case LinkedFields(a, b) =>
+            a :: b :: HNil
+        }
+      )
+    }
+
+    /**
+      * Transform a linked list of squad position data into a normal `List`.
+      * @param list the current section of the original linked list
+      * @param out the accumulative traditional `List`
+      * @return the final `List` output
+      */
+    @tailrec
+    private def unlinkFields(list : LinkedFields, out : List[SquadPositionDetail] = Nil) : List[SquadPositionDetail] = {
+      list.next match {
+        case None =>
+          out :+ list.info
+        case Some(next) =>
+          unlinkFields(next, out :+ list.info)
+      }
+    }
+
+    /**
+      * Transform a normal `List` of squad position data into a linked list.
+      * The original list becomes reversed in the process.
+      * @param list the original traditional `List`
+      * @return the final linked list output
+      */
+    private def linkFields(list : List[SquadPositionDetail]) : LinkedFields = {
+      list match {
+        case Nil =>
+          throw new Exception("")
+        case x :: Nil =>
+          LinkedFields(x, None)
+        case x :: xs =>
+          linkFields(xs, LinkedFields(x, None))
+      }
+    }
+
+    /**
+      * Transform a normal `List` of squad position data into a linked list.
+      * The original list becomes reversed in the process.
+      * @param list the current subsection of the original traditional `List`
+      * @param out the accumulative linked list
+      * @return the final linked list output
+      */
+    @tailrec
+    private def linkFields(list : List[SquadPositionDetail], out : LinkedFields) : LinkedFields = {
+      list match {
+        case Nil =>
+          out
+        case x :: Nil =>
+          LinkedFields(x, Some(out))
+        case x :: xs =>
+          linkFields(xs, LinkedFields(x, Some(out)))
+      }
+    }
+
+    /**
+      * Entry point.
+      */
+    val codec : Codec[SquadDetail] = {
+      import shapeless.::
+      (
+        ("unk1" | uint8) ::
+          ("unk2" | uint24) :: //unknown, but can be 0'd
+          ("leader_char_id" | uint32L) ::
+          ("unk3" | uint32L) :: //variable fields, but can be 0'd
+          ("leader" | PacketHelpers.encodedWideStringAligned(7)) ::
+          ("task" | PacketHelpers.encodedWideString) ::
+          ("zone_id" | PlanetSideZoneID.codec) ::
+          ("unk7" | uint(23)) :: //during full squad mode, constant = 4983296
+          optional(bool, "member_info" | initial_member_codec)
+        ).exmap[SquadDetail] (
+        {
+          case u1 :: u2 :: char_id :: u3 :: leader :: task :: zone :: unk7 :: Some(member_list) :: HNil =>
+            Attempt.Successful(
+              SquadDetail(Some(u1), Some(u2), Some(char_id), Some(u3), Some(leader), Some(task), Some(zone), Some(unk7),
+                Some(unlinkFields(member_list).zipWithIndex.map { case (entry, index) => SquadPositionEntry(index, Some(entry)) })
+              )
+            )
+          case data =>
+            Attempt.failure(Err(s"can not get squad detail definition from data $data"))
+        },
+        {
+          case SquadDetail(Some(u1), Some(u2), Some(char_id), Some(u3), Some(leader), Some(task), Some(zone), Some(unk7), Some(member_list)) =>
+            Attempt.Successful(
+              math.max(u1, 1) :: u2 :: char_id :: u3 :: leader :: task :: zone :: unk7 ::
+                Some(linkFields(member_list.collect { case SquadPositionEntry(_, Some(entry)) => entry }.reverse)) ::
+                HNil
+            )
+        }
+      )
+    }
+  }
+
+  /**
+    * The patterns necessary to read coded squad data fields.
+    * Any number of squad fields can be parsed,
+    * but the number is always counted and the fields are always preceded by a unique action code.
+    * Only important fields are listed as if to update them;
+    * unlisted fields indicate fields that do not get updated from their current values.
+    */
+  object ItemizedSquad {
+    /**
+      * A pattern for data related to "field1."
+      */
+    private val field1Codec : Codec[SquadDetail] = uint16L.exmap[SquadDetail] (
+      unk1 => Attempt.successful(SquadDetail(Some(unk1), None, None, None, None, None, None, None, None)),
+      {
+        case SquadDetail(Some(unk1), _, _, _,  _, _, _, _, _) =>
+          Attempt.successful(unk1)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for unknown field #1"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad leader's `char_id` field.
+      */
+    private val leaderCharIdCodec : Codec[SquadDetail] = uint32L.exmap[SquadDetail] (
+      char_id => Attempt.successful(SquadDetail(None, None, Some(char_id), None, None, None, None, None, None)),
+      {
+        case SquadDetail(_, _, Some(char_id), _,  _, _, _, _, _) =>
+          Attempt.successful(char_id)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for leader id"))
+      }
+    )
+    /**
+      * A pattern for data related to "field3."
+      */
+    private val field3Codec : Codec[SquadDetail] = uint32L.exmap[SquadDetail] (
+      unk3 => Attempt.successful(SquadDetail(None, None, None, Some(unk3), None, None, None, None, None)),
+      {
+        case SquadDetail(_, _, _, Some(unk3),  _, _, _, _, _) =>
+          Attempt.successful(unk3)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for unknown field #3"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad leader's `name` field.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def leaderNameCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadDetail] (
+      name => Attempt.successful(SquadDetail(None, None, None, None, Some(name), None, None, None, None)),
+      {
+        case SquadDetail(_, _, _, _, Some(name), _, _, _, _) =>
+          Attempt.successful(name)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for leader name"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad's `task` field, also often described as the squad description.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def taskCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadDetail] (
+      task => Attempt.successful(SquadDetail(None, None, None, None, None, Some(task), None, None, None)),
+      {
+        case SquadDetail(_, _, _, _, _, Some(task), _, _, _) =>
+          Attempt.successful(task)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for task"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad leader's `zone_id` field.
+      * @see `PlanetSideZoneID.codec`
+      */
+    private val zoneCodec : Codec[SquadDetail] = PlanetSideZoneID.codec.exmap[SquadDetail] (
+      zone_id => Attempt.successful(SquadDetail(None, None, None, None, None, None, Some(zone_id), None, None)),
+      {
+        case SquadDetail(_, _, _, _, _, _, Some(zone_id), _, _) =>
+          Attempt.successful(zone_id)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for zone id"))
+      }
+    )
+    /**
+      * A pattern for data related to "field7."
+      */
+    private val field7Codec : Codec[SquadDetail] = {
+      uint4.exmap[SquadDetail] (
+        unk7 => Attempt.successful(SquadDetail(None, None, None, None, None, None, None, Some(unk7), None)),
+        {
+          case SquadDetail(_, _, _,  _, _, _, _, Some(unk7), _) =>
+            Attempt.successful(unk7)
+          case _ =>
+            Attempt.failure(Err("failed to encode squad data for unknown field #7"))
+        }
+      )
+    }
+    /**
+      * A pattern for data related to the squad's position entry fields.
+      * The actual parsing of the data for the positions diverges
+      * into either an itemized parsing pattern
+      * or a fully populated parsing pattern.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def membersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
+      import shapeless.::
+      (
+        //TODO you can replace this outer structure with an either Codec
+        bool >>:~ { flag =>
+          conditional(flag, {
+            bitsOverByte.Add(4)
+            uint(3) :: vector(ItemizedPositions.codec(bitsOverByte))
+          }) ::
+            conditional(!flag, {
+              bitsOverByte.Add(3)
+              uint(2) :: FullyPopulatedPositions.codec(bitsOverByte)
+            })
+        }
+        ).exmap[SquadDetail] (
+        {
+          case true :: Some(_ :: member_list :: HNil) :: _ :: HNil =>
+            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(member_list.toList)))
+          case false :: None :: Some(_ :: member_list :: HNil) :: HNil =>
+            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(member_list.toList)))
+        },
+        {
+          case SquadDetail(_, _, _, _, _, _, _, _, Some(member_list)) =>
+            if(member_list
+              .collect { case position if position.info.nonEmpty =>
+                val info = position.info.get
+                List(info.is_closed, info.role, info.detailed_orders, info.requirements, info.char_id, info.name)
+              }
+              .flatten
+              .count(_.isEmpty) == 0) {
+              Attempt.successful(false :: None :: Some(2 :: member_list.toVector :: HNil) :: HNil)
+            }
+            else {
+              Attempt.successful(true :: Some(4 :: member_list.toVector :: HNil) :: None :: HNil)
+            }
+          case _ =>
+            Attempt.failure(Err("failed to encode squad data for members"))
+        }
+      )
+    }
+    /**
+      * A failing pattern for when the coded value is not tied to a known field pattern.
+      * This pattern does not read or write any bit data.
+      * The `conditional` will always return `None` because
+      * its determining conditional statement is explicitly `false`
+      * and all cases involving explicit failure.
+      * @param code the unknown action code
+      */
+    private def failureCodec(code : Int) : Codec[SquadDetail] = conditional(included = false, bool).exmap[SquadDetail] (
+      _ => Attempt.failure(Err(s"decoding squad data with unhandled codec - $code")),
+      _ => Attempt.failure(Err(s"encoding squad data with unhandled codec - $code"))
+    )
+
+    /**
+      * Retrieve the field pattern by its associated action code.
+      * @param code the action code
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return the field pattern
+      */
+    private def selectCodedAction(code : Int, bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
+      code match {
+        case 1 => field1Codec
+        case 2 => leaderCharIdCodec
+        case 3 => field3Codec
+        case 4 => leaderNameCodec(bitsOverByte)
+        case 5 => taskCodec(bitsOverByte)
+        case 6 => zoneCodec
+        case 7 => field7Codec
+        case 8 => membersCodec(bitsOverByte)
+        case _ => failureCodec(code)
+      }
+    }
+
+    /**
+      * Advance information about the current stream length because on which pattern was previously utilized.
+      * @see `selectCodedAction(Int, StreamLengthToken)`
+      * @param code the action code, connecting to a field pattern
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return a modified token maintaining stream misalignment
+      */
+    private def modifyCodedPadValue(code : Int, bitsOverByte : StreamLengthToken) : StreamLengthToken = {
+      code match {
+        case 1 => bitsOverByte //16u = no added padding
+        case 2 => bitsOverByte //32u = no added padding
+        case 3 => bitsOverByte //32u = no added padding
+        case 4 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
+        case 5 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
+        case 6 => bitsOverByte //32u = no added padding
+        case 7 => bitsOverByte.Add(4) //additional 4u
+        case 8 => bitsOverByte.Length = 0 //end of stream
+        case _ => bitsOverByte.Length = Int.MinValue //wildly incorrect
+      }
+    }
+
+    /**
+      * Internal class for linked list operations.
+      * @param code action code indicating the squad field
+      * @param info data for the squad field
+      * @param next if there is a "next" squad field
+      */
+    private final case class LinkedFields(code : Int, info : SquadDetail, next : Option[LinkedFields])
+
+    /**
+      * Transform a linked list of individual squad field data into a combined squad data object.
+      * @param list the current section of the original linked list
+      * @return the final squad object output
+      */
+    private def unlinkFields(list : LinkedFields) : SquadDetail = unlinkFields(Some(list))
+
+    /**
+      * Transform a linked list of individual squad field data into a combined squad data object.
+      * @param info the current section of the original linked list
+      * @param out the accumulative squad data object
+      * @return the final squad object output
+      */
+    @tailrec
+    private def unlinkFields(info : Option[LinkedFields], out : SquadDetail = SquadDetail.Blank) : SquadDetail = {
+      info match {
+        case None =>
+          out
+        case Some(sqInfo) =>
+          unlinkFields(sqInfo.next, out And sqInfo.info)
+      }
+    }
+
+    /**
+      * Transform a squad detail object whose field population may be sparse into a linked list of individual fields.
+      * Fields of the combined object are separated into a list of pairs
+      * of each of those fields's action codes and a squad detail object with only that given field populated.
+      * After the blank entries are eliminated, the remaining fields are transformed into a linked list.
+      * @param info the combined squad detail object
+      * @return the final linked list output
+      */
+    private def linkFields(info : SquadDetail) : LinkedFields = {
+      Seq(
+        (8, SquadDetail(None, None, None, None, None, None, None, None, info.member_info)),
+        (7, SquadDetail(None, None, None, None, None, None, None, info.unk7, None)),
+        (6, SquadDetail(None, None, None, None, None, None, info.zone_id, None, None)),
+        (5, SquadDetail(None, None, None, None, None, info.task, None, None, None)),
+        (4, SquadDetail(None, None, None, None, info.leader_name, None, None, None, None)),
+        (3, SquadDetail(None, None, None, info.unk3, None, None, None, None, None)),
+        (2, SquadDetail(None, None, info.leader_char_id, None, None, None, None, None, None)),
+        (1, SquadDetail(info.unk1, None, None, None, None, None, None, None, None))
+      ) //in reverse order so that the linked list is in the correct order
+        .filterNot { case (_, sqInfo) => sqInfo == SquadDetail.Blank}
+      match {
+        case Nil =>
+          throw new Exception("no linked list squad fields encountered where at least one was expected") //bad end
+        case x :: Nil =>
+          val (code, squadInfo) = x
+          LinkedFields(code, squadInfo, None)
+        case x :: xs =>
+          val (code, squadInfo) = x
+          linkFields(xs, LinkedFields(code, squadInfo, None))
+      }
+    }
+
+    /**
+      * Transform a `List` of squad field data paired with its field action code into a linked list.
+      * @param list the current subsection of the original list of fields
+      * @param out the accumulative linked list
+      * @return the final linked list output
+      */
+    @tailrec
+    private def linkFields(list : Seq[(Int, SquadDetail)], out : LinkedFields) : LinkedFields = {
+      if(list.isEmpty) {
+        out
+      }
+      else {
+        val (code, data) = list.head
+        linkFields(list.tail, LinkedFields(code, data, Some(out)))
+      }
+    }
+
+    /**
+      * Parse each action code to determine the format of the following squad field.
+      * Keep parsing until all reported squad fields have been encountered.
+      * @param size the number of fields to be parsed
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return a linked list composed of the squad fields
+      */
+    private def chain_linked_fields(size : Int, bitsOverByte : StreamLengthToken) : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        //disruptive coupling action (e.g., flatPrepend) is necessary for recursive Codec
+        uint4 >>:~ { code =>
+          selectCodedAction(code, bitsOverByte.Add(4)) ::
+            conditional(size - 1 > 0, chain_linked_fields(size - 1, modifyCodedPadValue(code, bitsOverByte)))
+        }
+        ).exmap[LinkedFields] (
+        {
+          case action :: detail :: next :: HNil =>
+            Attempt.Successful(LinkedFields(action, detail, next))
+        },
+        {
+          case LinkedFields(action, detail, next) =>
+            Attempt.Successful(action :: detail :: next :: HNil)
+        }
+      )
+    }
+
+    /**
+      * Entry point.
+      * The stream misalignment will always be by 1 bit over the previous boundary when this is invoked.
+      * @param size the number of squad fields to be parsed
+      * @return a pattern for parsing the coded squad field data between a coded linked list and a combined squad object
+      */
+    def codec(size : Int) : Codec[SquadDetail] = chain_linked_fields(size, new StreamLengthToken(1)).xmap[SquadDetail] (
+      linkedDetail => unlinkFields(linkedDetail),
+      unlinkedDetail => linkFields(unlinkedDetail)
+    )
+  }
+
+  /**
+    * The patterns necessary to read coded itemized squad position data fields.
+    * The main squad position data has been completed and now the squad's open positions are being parsed.
+    * Any number of squad position fields can be parsed,
+    * but the number is always counted and the fields are always preceded by a unique action code.
+    * Only important fields are listed as if to update them;
+    * unlisted fields indicate fields that do not get updated from their current values.
+    */
+  object ItemizedPositions {
+    /**
+      * A pattern for data related to the squad position's `is_closed` field.
+      */
+    private val isClosedCodec : Codec[SquadPositionDetail] = bool.exmap[SquadPositionDetail] (
+      state => Attempt.successful(SquadPositionDetail(Some(state), None, None, None, None, None)),
+      {
+        case SquadPositionDetail(Some(state), _, _, _, _, _) =>
+          Attempt.successful(state)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad position data for availability"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad position's `role` field.
+      * @see `SquadDetailDefinitionUpdateMessage.paddedStringMetaCodec`
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def roleCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail] (
+      role => Attempt.successful(SquadPositionDetail(None, Some(role), None, None, None, None)),
+      {
+        case SquadPositionDetail(_, Some(role), _, _, _, _) =>
+          Attempt.successful(role)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad position data for role"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad position's `detailed_orders` field.
+      * @see `SquadDetailDefinitionUpdateMessage.paddedStringMetaCodec`
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def ordersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail] (
+      orders => Attempt.successful(SquadPositionDetail(None, None, Some(orders), None, None, None)),
+      {
+        case SquadPositionDetail(_, _, Some(orders), _, _, _) =>
+          Attempt.successful(orders)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad position data for detailed orders"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad position's `requirements` field.
+      * @see `CertificationType.fromEncodedLong`
+      * @see `CertificationType.toEncodedLong`
+      * @see `SquadDefinitionActionMessage.ChangeSquadMemberRequirementsCertifications`
+      */
+    private val requirementsCodec : Codec[SquadPositionDetail] = ulongL(46).exmap[SquadPositionDetail] (
+      requirements => Attempt.successful(SquadPositionDetail(None, None, None, Some(CertificationType.fromEncodedLong(requirements)), None, None)),
+      {
+        case SquadPositionDetail(_, _, _, Some(requirements), _, _) =>
+          Attempt.successful(CertificationType.toEncodedLong(requirements))
+        case _ =>
+          Attempt.failure(Err("failed to encode squad position data for certification requirements"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad position's `char_id` field, when occupied.
+      */
+    private val charIdCodec : Codec[SquadPositionDetail] = uint32L.exmap[SquadPositionDetail] (
+      char_id => Attempt.successful(SquadPositionDetail(None, None, None, None, Some(char_id), None)),
+      {
+        case SquadPositionDetail(_, _, _, _, Some(char_id), _) =>
+          Attempt.successful(char_id)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad data for member id"))
+      }
+    )
+    /**
+      * A pattern for data related to the squad position's `name` field, when occupied.
+      * @see `SquadDetailDefinitionUpdateMessage.paddedStringMetaCodec`
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def nameCodec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadPositionDetail] (
+      name => Attempt.successful(SquadPositionDetail(None, None, None, None, None, Some(name))),
+      {
+        case SquadPositionDetail(_, _, _, _, _, Some(orders)) =>
+          Attempt.successful(orders)
+        case _ =>
+          Attempt.failure(Err("failed to encode squad position data for member name"))
+      }
+    )
+    /**
+      * A failing pattern for when the coded value is not tied to a known field pattern.
+      * This pattern does not read or write any bit data.
+      * The `conditional` will always return `None` because
+      * its determining conditional statement is explicitly `false`
+      * and all cases involving explicit failure.
+      * @param code the unknown action code
+      */
+    private def failureCodec(code : Int) : Codec[SquadPositionDetail] = conditional(included = false, bool).exmap[SquadPositionDetail] (
+      _ => Attempt.failure(Err(s"decoding squad position data with unhandled codec - $code")),
+      _ => Attempt.failure(Err(s"encoding squad position data with unhandled codec - $code"))
+    )
+
+    /**
+      * Retrieve the field pattern by its associated action code.
+      * @param code the action code
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return the field pattern
+      */
+    private def selectCodedAction(code : Int, bitsOverByte : StreamLengthToken) : Codec[SquadPositionDetail] = {
+      code match {
+        case 0 => isClosedCodec
+        case 1 => roleCodec(bitsOverByte)
+        case 2 => ordersCodec(bitsOverByte)
+        case 3 => charIdCodec
+        case 4 => nameCodec(bitsOverByte)
+        case 5 => requirementsCodec
+        case _ => failureCodec(code)
+      }
+    }
+
+    /**
+      * Advance information about the current stream length because on which pattern was previously utilized.
+      * @see `selectCodedAction(Int, StreamLengthToken)`
+      * @param code the action code, connecting to a field pattern
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return a modified token maintaining stream misalignment
+      */
+    private def modifyCodedPadValue(code : Int, bitsOverByte : StreamLengthToken) : StreamLengthToken = {
+      code match {
+        case 0 => bitsOverByte.Add(1) //additional 1u
+        case 1 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
+        case 2 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
+        case 3 => bitsOverByte //32u = no added padding
+        case 4 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
+        case 5 => bitsOverByte.Add(6) //46u = 5*8u + 6u = additional 6u
+        case _ => bitsOverByte.Length = Int.MinValue //wildly incorrect
+      }
+    }
+
+    /**
+      * Internal class for linked list operations.
+      * @param code action code indicating the squad position field
+      * @param info data for the squad position field
+      * @param next if there is a "next" squad position field
+      */
+    private final case class LinkedFields(code : Int, info : SquadPositionDetail, next : Option[LinkedFields])
+
+    /**
+      * Transform a linked list of individual squad position field data into a combined squad position object.
+      * @param info the current section of the original linked list
+      * @param out the accumulative squad position data object
+      * @return the final squad position object output
+      */
+    @tailrec
+    private def unlinkFields(info : Option[LinkedFields], out : SquadPositionDetail = SquadPositionDetail.Blank) : SquadPositionDetail = {
+      info match {
+        case None =>
+          out
+        case Some(sqInfo) =>
+          unlinkFields(sqInfo.next, out And sqInfo.info)
+      }
+    }
+
+    /**
+      * Transform a squad position object whose field population may be sparse into a linked list of individual fields.
+      * Fields of the combined object are separated into a list of pairs
+      * of each of those fields's action codes and a squad position object with only that given field populated.
+      * After the blank entries are eliminated, the remaining fields are transformed into a linked list.
+      * @param info the combined squad position object
+      * @return the final linked list output
+      */
+    private def linkFields(info : SquadPositionDetail) : LinkedFields = {
+      Seq(
+        (5, SquadPositionDetail(None, None, None, info.requirements, None, None)),
+        (4, SquadPositionDetail(None, None, None, None, None, info.name)),
+        (3, SquadPositionDetail(None, None, None, None, info.char_id, None)),
+        (2, SquadPositionDetail(None, None, info.detailed_orders, None, None, None)),
+        (1, SquadPositionDetail(None, info.role, None, None, None, None)),
+        (0, SquadPositionDetail(info.is_closed, None, None, None, None, None))
+      ) //in reverse order so that the linked list is in the correct order
+        .filterNot { case (_, sqInfo) => sqInfo == SquadPositionDetail.Blank}
+      match {
+        case Nil =>
+          throw new Exception("no linked list squad position fields encountered where at least one was expected") //bad end
+        case x :: Nil =>
+          val (code, squadInfo) = x
+          LinkedFields(code, squadInfo, None)
+        case x :: xs =>
+          val (code, squadInfo) = x
+          linkFields(xs, LinkedFields(code, squadInfo, None))
+      }
+    }
+
+    /**
+      * Transform a `List` of squad position field data paired with its field action code into a linked list.
+      * @param list the current subsection of the original list of fields
+      * @param out the accumulative linked list
+      * @return the final linked list output
+      */
+    @tailrec
+    private def linkFields(list : Seq[(Int, SquadPositionDetail)], out : LinkedFields) : LinkedFields = {
+      if(list.isEmpty) {
+        out
+      }
+      else {
+        val (code, data) = list.head
+        linkFields(list.tail, LinkedFields(code, data, Some(out)))
+      }
+    }
+
+    /**
+      * Parse each action code to determine the format of the following squad position field.
+      * Keep parsing until all reported squad position fields have been encountered.
+      * @param size the number of fields to be parsed
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      * @return a linked list composed of the squad position fields
+      */
+    private def chain_linked_fields(size : Int, bitsOverByte : StreamLengthToken) : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        uint4 >>:~ { code =>
+          selectCodedAction(code,  bitsOverByte.Add(4)) >>:~ { _ =>
+            modifyCodedPadValue(code, bitsOverByte)
+            conditional(size - 1 > 0, chain_linked_fields(size - 1, bitsOverByte)).hlist
+          }
+        }
+        ).xmap[LinkedFields] (
+        {
+          case code :: entry :: next :: HNil =>
+            LinkedFields(code, entry, next)
+        },
+        {
+          case LinkedFields(code, entry, next) =>
+            code :: entry :: next :: HNil
+        }
+      )
+    }
+
+    /**
+      * Parse the number of squad position fields anticipated and then start parsing those position fields.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def squad_member_details_codec(bitsOverByte : StreamLengthToken) : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        uint8 >>:~ { size =>
+          chain_linked_fields(size, bitsOverByte).hlist
+        }
+        ).xmap[LinkedFields] (
+        {
+          case _ :: info :: HNil =>
+            info
+        },
+        info => {
+          //count the linked position fields by tracing the "next" field in the linked list
+          var i = 1
+          var dinfo = info
+          while(dinfo.next.nonEmpty) {
+            i += 1
+            dinfo = dinfo.next.get
+          }
+          i :: info :: HNil
+        }
+      )
+    }
+
+    /**
+      * Entry point.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    def codec(bitsOverByte : StreamLengthToken) : Codec[SquadPositionEntry] = {
+      import shapeless.::
+      (
+        ("index" | uint8) >>:~ { index =>
+          conditional(index < 255, bool :: squad_member_details_codec(bitsOverByte.Add(1))) ::
+            conditional(index == 255, bits)
+        }
+        ).xmap[SquadPositionEntry] (
+        {
+          case 255 :: _ :: _ :: HNil =>
+            SquadPositionEntry(255, None)
+          case ndx :: Some(_ :: info :: HNil) :: _ :: HNil =>
+            SquadPositionEntry(ndx, Some(unlinkFields(Some(info))))
+        },
+        {
+          case SquadPositionEntry(255, _) =>
+            255 :: None :: None :: HNil
+          case SquadPositionEntry(ndx, Some(info)) =>
+            ndx :: Some(true :: linkFields(info) :: HNil) :: None :: HNil
+        }
+      )
+    }
+  }
+
+  /**
+    * The patterns necessary to read enumerated squad position data.
+    * The main squad position data has been completed and now the squad's open positions are being parsed.
+    * These patterns split the difference between `FullSquad` operations and `ItemizedSquad` operations.
+    * Normally the whole of the squad position data is parsed in a single pass in `FullSquad`
+    * and, during `ItemizedSquad`, only piecemeal squad position fields are parsed.
+    * Furthermore, `FullSquad` position data is un-indexed because it is always presented in correct order,
+    * and `ItemizedSquad` positional data is indexed because it can skip entries and may be encountered in any order.
+    * These patterns parse full squad position data that is also indexed.
+    */
+  object FullyPopulatedPositions {
+    /**
+      * The primary difference between the cores of `FullSquad` position data and `FullyPopulatedPositions` data,
+      * besides variable padding,
+      * involves the `requirements` field not having a basic set of values that are always masked.
+      * @param bitsOverByteLength a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def position_codec(bitsOverByteLength : Int) : Codec[SquadPositionDetail] = basePositionCodec(bitsOverByteLength, Set.empty)
+
+    /**
+      * Internal class for linked list operations.
+      * @param index the current position's ordinal number
+      * @param info data for the squad position field
+      * @param next if there is a "next" squad position field
+      */
+    private final case class LinkedFields(index: Int, info: SquadPositionDetail, next: Option[LinkedFields])
+
+    /**
+      * Transform a linked list of squad position data into a normal `List`.
+      * @param list the current section of the original linked list
+      * @param out the accumulative traditional `List`
+      * @return the final `List` output
+      */
+    @tailrec
+    private def unlinkFields(list : LinkedFields, out : List[SquadPositionEntry] = Nil) : List[SquadPositionEntry] = {
+      list.next match {
+        case None =>
+          out :+ SquadPositionEntry(list.index, list.info)
+        case Some(next) =>
+          unlinkFields(next, out :+ SquadPositionEntry(list.index, list.info))
+      }
+    }
+
+    /**
+      * Transform a normal `List` of squad position data into a linked list.
+      * The original list becomes reversed in the process.
+      * @param list the original traditional `List`
+      * @return the final linked list output
+      */
+    private def linkFields(list : List[SquadPositionEntry]) : LinkedFields = {
+      list match {
+        case Nil =>
+          throw new Exception("")
+        case x :: xs if x.info.isEmpty =>
+          linkFields(xs, LinkedFields(x.index, SquadPositionDetail.Blank, None))
+        case x :: xs =>
+          linkFields(xs, LinkedFields(x.index, x.info.get, None))
+      }
+    }
+
+    /**
+      * Transform a normal `List` of squad position data into a linked list.
+      * The original list becomes reversed in the process.
+      * @param list the current subsection of the original traditional `List`
+      * @param out the accumulative linked list
+      * @return the final linked list output
+      */
+    @tailrec
+    private def linkFields(list : List[SquadPositionEntry], out : LinkedFields) : LinkedFields = {
+      list match {
+        case Nil =>
+          out
+        case x :: _ if x.info.isEmpty =>
+          LinkedFields(x.index, SquadPositionDetail.Blank, Some(out))
+        case x :: Nil =>
+          LinkedFields(x.index, x.info.get, Some(out))
+        case x :: xs =>
+          linkFields(xs, LinkedFields(x.index, x.info.get, Some(out)))
+      }
+    }
+
+    /**
+      * All squad position entries asides from the first have unpadded strings.
+      * The very first entry aligns the remainder of the string fields along byte boundaries.
+      */
+    private def subsequent_position_codec(size : Int) : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        uint8 >>:~ { index =>
+          conditional(index < 255, bool :: position_codec(bitsOverByteLength = 0)) ::
+            conditional(size - 1 > 0, subsequent_position_codec(size - 1)) ::
+            conditional(index == 255, bits)
+        }
+        ).xmap[LinkedFields](
+        {
+          case 255 :: _ :: _ :: _ :: HNil =>
+            LinkedFields(255, SquadPositionDetail.Blank, None)
+          case index :: Some(_ :: entry :: HNil) :: next :: _ :: HNil =>
+            LinkedFields(index, entry, next)
+        },
+        {
+          case LinkedFields(255, _, _) =>
+            255 :: None :: None :: None :: HNil
+          case LinkedFields(index, entry, next) =>
+            index :: Some(true :: entry :: HNil) :: next :: None :: HNil
+        }
+      )
+    }
+
+    /**
+      * The first squad position entry has its first string (`role`) field padded by an amount that can be determined.
+      * @param size the number of position entries to be parsed
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    private def initial_position_codec(size : Int, bitsOverByte : StreamLengthToken) : Codec[LinkedFields] = {
+      import shapeless.::
+      (
+        uint8 >>:~ { index =>
+          conditional(index < 255, {
+            bitsOverByte.Add(2) //1 (below) + 1 (position_codec)
+            bool :: position_codec(bitsOverByte.Length)
+          }) ::
+            conditional(index < 255 && size - 1 > 0, subsequent_position_codec(size - 1)) ::
+            conditional(index == 255, bits)
+        }
+        ).xmap[LinkedFields](
+        {
+          case 255 :: _ :: _ :: _ :: HNil =>
+            LinkedFields(255, SquadPositionDetail.Blank, None)
+          case index :: Some(_ :: entry :: HNil) :: next :: _ :: HNil =>
+            LinkedFields(index, entry, next)
+        },
+        {
+          case LinkedFields(255, _, _) =>
+            255 :: None :: None :: None :: HNil
+          case LinkedFields(index, entry, next) =>
+            index :: Some(true :: entry :: HNil) :: next :: None :: HNil
+        }
+      )
+    }
+
+    /**
+      * Entry point.
+      * @param bitsOverByte a token maintaining stream misalignment for purposes of calculating string padding
+      */
+    def codec(bitsOverByte : StreamLengthToken) : Codec[Vector[SquadPositionEntry]] = {
+      import shapeless.::
+      (
+        uint32L >>:~ { size =>
+          bitsOverByte.Add(4)
+          uint4 ::
+            initial_position_codec(size.toInt + 1, bitsOverByte)
+        }).xmap[Vector[SquadPositionEntry]] (
+        {
+          case _ :: _ :: linkedMembers :: HNil =>
+            unlinkFields(linkedMembers).toVector
+        },
+        //TODO "memberList.size - 1"? the only two examples are "10" anyway
+        memberList => memberList.size - 1 :: 12 :: linkFields(memberList.reverse.toList) :: HNil
+      )
+    }
+  }
+
+  /**
+    * Certification values that are front-loaded into the `FullSquad` operations for finding squad position requirements.
+    * In the game proper, these are three certification values that the user can not give up or interact with.
+    */
   final val DefaultRequirements : Set[CertificationType.Value] = Set(
     CertificationType.StandardAssault,
     CertificationType.StandardExoSuit,
     CertificationType.AgileExoSuit
   )
 
-  final val Init = SquadDetailDefinitionUpdateMessage(
-    PlanetSideGUID(0),
-    SquadDetail(
-      0,
-      0,
-      0L,
-      0L,
-      "",
-      "",
-      PlanetSideZoneID(0),
-      0,
-      (0 to 9).map { i => SquadPositionEntry(i, SquadPositionDetail2.Blank)} toList
-    )
-  )
-
-
-  /*
-  DECOY CONSTRUCTORS
-   */
-  def apply(guid : PlanetSideGUID,
-             unk1 : Int,
-             leader_char_id : Long,
-             unk2 : BitVector,
-             leader_name : String,
-             task : String,
-             zone_id : PlanetSideZoneID,
-             member_info : List[SquadPositionDetail]) : SquadDetailDefinitionUpdateMessage = {
-    SquadDetailDefinitionUpdateMessage(PlanetSideGUID(0), SquadDetail.Blank)
-  }
-  def apply(guid : PlanetSideGUID, char_id : Long, leader_name : String, task : String, zone_id : PlanetSideZoneID, member_info : List[SquadPositionDetail]) : SquadDetailDefinitionUpdateMessage = {
-    SquadDetailDefinitionUpdateMessage(PlanetSideGUID(0), SquadDetail.Blank)
-  }
+  /**
+    * Blank squad data set up for `FullSquad` parsing.
+    * The `guid` value is significant - it represents the client-local squad data.
+    */
+  final val Init = SquadDetailDefinitionUpdateMessage(PlanetSideGUID(0), SquadDetail().Complete)
 
   /**
-    * Produces a `Codec` function for byte-aligned, padded Pascal strings encoded through common manipulations.
+    * Produces a byte-aligned Pascal strings encoded through common manipulations.
+    * Rather than pass in the amount of the padding directly, however,
+    * the stream length or the misalignment to the stream's previous byte boundary is passed into the function
+    * and is converted into the proper padding value.
     * @see `PacketHelpers.encodedWideStringAligned`
     * @param bitsOverByte the number of bits past the previous byte-aligned index;
-    *             should be a 0-7 number that gets converted to a 1-7 string padding number
-    * @return the encoded string `Codec`
+    *             gets converted to a 0-7 string padding number based on how many bits remain befoire the next byte
+    * @return the padded string `Codec`
     */
-  def paddedStringMetaCodec(bitsOverByte : Int) : Codec[String] = PacketHelpers.encodedWideStringAligned({
+  private def paddedStringMetaCodec(bitsOverByte : Int) : Codec[String] = PacketHelpers.encodedWideStringAligned({
     val mod8 = bitsOverByte % 8
     if(mod8 == 0) {
       0
